﻿Imports Infragistics.Documents.Excel
Imports Infragistics.Win
Imports Infragistics.Win.UltraWinEditors

Public Class Form1
    Private _theCellFormat As IWorksheetCellFormat = Nothing
    Private Sub UltraGrid1_InitializeRow(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeRowEventArgs) Handles UltraGrid1.InitializeRow
        If e.Row.Index = 0 Then
            Dim EditorSettings As New DefaultEditorOwnerSettings
            EditorSettings.DataType = GetType([Decimal])
            EditorSettings.Format = "0'%"
            Dim editor = New EditorWithText(New DefaultEditorOwner(EditorSettings))
            e.Row.Cells("Id").Editor = editor
        End If
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Me.UltraGridExcelExporter1.Export(Me.UltraGrid1, "test.xlsx")
    End Sub

    Private Sub UltraGridExcelExporter1_CellExporting(sender As Object, e As UltraWinGrid.ExcelExport.CellExportingEventArgs) Handles UltraGridExcelExporter1.CellExporting
        If e.CurrentColumnIndex = 0 And e.CurrentRowIndex = 1 Then
            e.Cancel = True

            If _theCellFormat Is Nothing Then
                _theCellFormat = e.Workbook.CreateNewWorksheetCellFormat()
                _theCellFormat.FormatString = "0\%"
            End If

            Dim Worksheet = TryCast(e.CurrentWorksheet, Worksheet)
            Worksheet.Rows(1).Cells(0).Value = e.GridValue
            Worksheet.Rows(1).Cells(0).CellFormat.SetFormatting(_theCellFormat)

        End If
    End Sub
End Class
